DiscHarrowMulcher = {}

function DiscHarrowMulcher.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Cultivator, specializations)
end

function DiscHarrowMulcher.registerOverwrittenFunctions(vehicleType)
    SpecializationUtil.registerOverwrittenFunction(vehicleType, "processCultivatorArea", DiscHarrowMulcher.processCultivatorArea)
end

function DiscHarrowMulcher.registerEventListeners(vehicleType)
    SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", DiscHarrowMulcher)
end

function DiscHarrowMulcher:onPostLoad(savegame)
    local spec = self.spec_cultivator
	spec.isDiscHarrow = not spec.useDeepMode and g_storeManager:getItemByXMLFilename(self.configFileName).categoryName == g_storeManager:getCategoryByName("discHarrows").name
end

function DiscHarrowMulcher:processCultivatorArea(superFunc, workArea, dt)
	if self.spec_cultivator.isDiscHarrow then
		local xs, _, zs = getWorldTranslation(workArea.start)
		local xw, _, zw = getWorldTranslation(workArea.width)
		local xh, _, zh = getWorldTranslation(workArea.height)
		local _, _ = FSDensityMapUtil.updateMulcherArea(xs, zs, xw, zw, xh, zh)
	end
	local realArea, area = superFunc(self, workArea, dt)
	return realArea, area
end
